#include <cstdio>
#include <algorithm>
using namespace std;

int main(){
	int T;
	scanf("%d", &T);
	while(T--){
		int n, k, h[20000];
		scanf("%d%d", &n, &k);
		for(int i=0;i<n;++i) scanf("%d",h+i);
		sort(h,h+n);
		int ans=1000000001;
		for(int i=0;i+k-1<n;++i){
			ans=min(ans,h[i+k-1]-h[i]);
		}
		printf("%d\n",ans);
	}
}
